给你一个 无重复元素 的整数数组 candidates 和一个目标整数 target ,找出 candidates 中可以使数字和为目标数 target 的 所有 不同组合 ,并以列表形式返回。你可以按 任意顺序 返回这些组合。
candidates 中的 同一个 数字可以 无限制重复被选取 。如果至少一个数字的被选数量不同,则两种组合是不同的。
对于给定的输入,保证和为 target 的不同组合数少于 150 个。
示例 1:
输入:candidates = [2,3,6,7], target = 7
输出:[[2,2,3],[7]]
解释:
2 和 3 可以形成一组候选,2 + 2 + 3 = 7 。注意 2 可以使用多次。
7 也是一个候选, 7 = 7 。
仅有这两种组合。
来源:力扣(LeetCode)
链接:https://leetcode.cn/problems/combination-sum
著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。
题解、回溯算法,注意每次可以选择重复元素,但是需要保证不是来回重复, 所以按照一定顺序遍历搜索,不重不漏。
- class Solution{
- public List<List<Integer>> combinationSum(int[] candidates, int target){
- List<List<Integer>> res = new ArrayList<>();
- Deque<Integer> path = new ArrayDeque<>();
- int len = candidates.length;
- dfs(candidates, 0, len, target, path, res);
- return res;
- }
- public void dfs(int[] candidates, int begin, int len, int target, Deque<Integer> path, List<List<Integer>> res){
- if(target < 0) return;
- if(target == 0){
- res.add(new ArrayList<>(path));
- return;
- }
- for(int i = begin; i < len; i++){
- path.addLast(candidates[i]);
- dfs(candidates, i, len, target - candidates[i], path, res);
- path.removeLast();
- }
- }
- }
排序后可剪枝,前面数据相加后被target做差,已小于0,后面更小于,所以可直接退出for循环。
- class Solution{
- public List<List<Integer>> combinationSum(int[] candidates, int target){
- List<List<Integer>> res = new ArrayList<>();
- Deque<Integer> path = new ArrayDeque<>();
- int len = candidates.length;
- Arrays.sort(candidates);
- dfs(candidates, 0, len, target, path, res);
- return res;
- }
- public void dfs(int[] candidates, int begin, int len, int target, Deque<Integer> path, List<List<Integer>> res){
- if(target == 0){
- res.add(new ArrayList<>(path));
- }
- for(int i = begin; i < len; i++){
- if((target - candidates[i]) < 0 ){
- break;
- }
- path.addLast(candidates[i]);
- dfs(candidates, i, len, target - candidates[i], path, res);
- path.removeLast();
- }
- }
- }